﻿package
{
	import flash.display.Sprite;
	import flash.events.*;
	import flash.display.Shape;
	import flash.ui.Mouse;
	
	public class Genever extends Sprite
	{
		private var lastMouseX:Number;
		private var lastMouseY:Number;
		private var minDistance:Number 	= 15;
		private var shapes:Array 		= new Array();
		private var shapeLimit:Number	= 60;

		
		
		public function Genever()
		{
			Mouse.hide();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			
			
			if (isNaN(lastMouseX)) lastMouseX = mouseX;
			if (isNaN(lastMouseY)) lastMouseY = mouseY;
			
		
				
			var dist = distance(mouseX, mouseY, lastMouseX, lastMouseY);
			
			if (dist > minDistance) {
				var newShape = new Forme();
				//newShape.rotation = Math.random()*60;
				newShape.x = mouseX;
				newShape.y = mouseY;

				addChild(newShape);
				
				shapes.push(newShape);
				
				if (shapes.length > shapeLimit) {
					var firstShape = shapes.shift();
					removeChild(firstShape);
				}
				
				lastMouseX = mouseX;
				lastMouseY = mouseY;
			}
		}
		
		
		private function distance(x1:Number, y1:Number, x2:Number, y2:Number):Number {
			return Math.sqrt(Math.pow(x2-x1, 2)+Math.pow(y2-y1, 2));			
		}
		
	}
}